/* Make FischeRandom Chess (FRC) positions */
/* Alain Brobecker, 06-Jun-2003 */

#include <stdio.h>
/* Change pieces' abbreviation here. */
#define King   'R' /* Rega    Roi      King   Knig    Re      Rey     */
#define Queen  'D' /* Damo    Dame     Queen  Dame     Donna   Dama    */
#define Rook   'T' /* Turo    Tour     Rook   Turm     Torre   Torre   */
#define Bishop 'F' /* Kuriero Fou      Bishop Laufer   Alfiere Alfil   */
#define Knight 'C' /* Cevalo  Cavalier kNight Springer Cavallo Caballo */
                   /* ?       pion     pawn   bauer    pedone  peon    */

#define width 5    /* Number of positions to print in a row */

int roi,tour1,tour2,fou1,fou2,dame,n,c,d;
char pos[9],FRCpos[960][9];
int rega[8],damo[8],turo[8],kuriero[8],cevalo[8];

int main()
{
/* Create FRC positions */
  n=0;
  for(roi=1;roi<7;roi++) { /* set king */
    for(tour1=0;tour1<roi;tour1++) { /* set left rook */
      for(tour2=roi+1;tour2<8;tour2++) { /* set right rook */
        for(fou1=0;fou1<7;fou1=fou1+2) { /* set 1st bishop */
          if((fou1!=roi) && (fou1!=tour1) && (fou1!=tour2)) {
            for(fou2=1;fou2<8;fou2=fou2+2) { /* set 2nd bishop */
              if((fou2!=roi) && (fou2!=tour1) && (fou2!=tour2)) {
                for(c=0;c<8;c++) { pos[c]=Knight; }
                pos[9]='\0';
                pos[roi]=King;
                pos[tour1]=Rook;
                pos[tour2]=Rook;
                pos[fou1]=Bishop;
                pos[fou2]=Bishop;
                for(dame=0;dame<8;dame++) { /* set queen */
                  if(pos[dame]==Knight) {
                    for(c=0;c<8;c++) { FRCpos[n][c]=pos[c]; }
                    FRCpos[n][dame]=Queen;
                    n++;
                  }
                }
              }
            }
          }
        }
      }
    }
  }
/* Statistics for pieces' positions (=verification) */
  for(c=0;c<8;c++) {
    rega[c]=0;
    damo[c]=0;
    turo[c]=0;
    kuriero[c]=0;
    cevalo[c]=0;
  }
  for(c=0;c<n;c++) {
    for(d=0;d<8;d++) {
      switch (FRCpos[c][d]) {
        case King:rega[d]++;break;
        case Queen:damo[d]++;break;
        case Rook:turo[d]++;break;
        case Bishop:kuriero[d]++;break;
        case Knight:cevalo[d]++;
      }
    }
  }
  printf("Roi: ");for(d=0;d<8;d++) { printf("  %3d",rega[d]); }
  printf("\nDame:");for(d=0;d<8;d++) { printf("  %3d",damo[d]); }
  printf("\nTour:");for(d=0;d<8;d++) { printf("  %3d",turo[d]); }
  printf("\nFou: ");for(d=0;d<8;d++) { printf("  %3d",kuriero[d]); }
  printf("\nCav.:");for(d=0;d<8;d++) { printf("  %3d",cevalo[d]); }
  printf("\n\n");
/* Print FRC positions */
  d=0;
  for(c=0;c<n;c++) {
    printf("%03d:%s   ",c,FRCpos[c]);
    d++;
    if(d==width) {
      printf("\n");
      d=0;
    }
  }
}
